#include "File.hpp"
#include <stdio.h>

bool readFile(const string &fileName, vector<unsigned char> *pBuf)
{
  pBuf->clear();

  FILE *inFile = fopen(fileName.c_str(), "rb");
  if (!inFile) {
    return false;
  }

  while (!feof(inFile)) {
    unsigned char tmpBuf[65536];

    int count = fread(tmpBuf,
                      sizeof(unsigned char),
                      65536,
                      inFile);

    if (count == 0) {
      fclose(inFile);
      return false;
    }

    int ii;
    for (ii = 0; ii < count; ii++) {
      pBuf->push_back(tmpBuf[ii]);
    }
  }

  fclose(inFile);

  return true;
}

bool writeFile(const string &fileName, const vector<unsigned char> &data)
{
  FILE *outFile = fopen(fileName.c_str(), "wb");
  if (!outFile) {
    return false;
  }

  int count = fwrite(&data[0], //.begin(),
                     sizeof(unsigned char),
                     data.size(),
                     outFile);

  if (count != (int)data.size()) {
    fclose(outFile);
    return false;
  }

  fclose(outFile);

  return true;
}
